import UIKit

// here are the inputs
var inputInts = [72,111,63,85,61,56,118,121,61,69,63,61]

// working on Output #1
var sum = 0
for number in inputInts {
    sum += number
}

print("Output #1 - Sum of inputs is: \(sum)")

// working on Output #2
var average :Float = 0.0
average = Float(sum) / Float(inputInts.count)
var averageInt :Int = Int(average)
// ceil is like rounding but forced up
var averageRemainder = Int(ceil(Float(inputInts.count) * (average - Float(averageInt))))

print("Output #2 - Average of inputs is: \(averageInt), \(averageRemainder)")

// working on Output #3
var arrayOfEvens = [Int]()
for number in inputInts {
    if ((Int(number / 2) * 2) == number) {
        arrayOfEvens.append(number)
    }
}

print("Output #3 - Even numbers: \(arrayOfEvens)")

// working on Output #4
var largest = 0
var largestPosition = 0
for n in 0..<inputInts.count {
    if (inputInts[n] > largest) {
        largest = inputInts[n]
        largestPosition = n
    }
}
// print("largest is \(largest) at position \(largestPosition)")
var smallest = largest
var smallestPosition = 0
for n in 0..<inputInts.count {
    if (inputInts[n] < largest) {
        smallest = inputInts[n]
        smallestPosition = n
    }
}

print("Output #4 - Smallest is \(smallest) in position \(smallestPosition)")

// working on Output #5
var repeats = [Int]()
var repeatsTotalCount = 0
var alreadyFoundThese = [Int]()

for lookingFor in inputInts {
    if (alreadyFoundThese.contains(lookingFor)) {
        // nothing to do if we've already found it once
    } else {
        var count = 0
        for thisPosition in inputInts {
            if (thisPosition == lookingFor) {
                count += 1
            }
        }
        if (count > 1) {
            for _ in 0..<count {
                repeats.append(lookingFor)
                repeatsTotalCount += 1
            }
        }
        alreadyFoundThese.append(lookingFor)
    }
}

print("Output #5 - Number of repeats: \(repeatsTotalCount) consisting of: \(repeats)")

// working on Output #6
// Ok the idea of laying down the two input numbers as a line of bits, end to end, then treating the pile of bits as another format by grouping them in a differen way is very cool .. but I had to google this one like crazy !!
inputInts[0]
let firstInt = Int8(inputInts[0])
let secondInt = Int8(inputInts[1])

let loopValues = [1,0]

func load16(incomingArray: [UInt8]) -> UInt16{
    var u: UInt16 = 0
    for index in loopValues {
        u = u << 8
        print (u)
        u = u | UInt16(incomingArray[index])
        print (u)
    }
    return u
}

var intsToCombine = [UInt8(inputInts[1]),UInt8(inputInts[0])]
var resultInt16 = load16(incomingArray: intsToCombine)

print("Output #6 - New number is: \(resultInt16)")

// working on Output #7
var sortArray = inputInts
var neededToSwapStuff = 1
var totalSortActions = 0
while (neededToSwapStuff > 0) {
    neededToSwapStuff = 0
    for number in 0..<(sortArray.count-1) {
        if (sortArray[number] > sortArray[number+1]){
            neededToSwapStuff += 1
            totalSortActions += 1
            let numberBeingMoved = sortArray[number]
            sortArray[number] = sortArray[number+1]
            sortArray[number+1] = numberBeingMoved
        }
    }
}

print("Output #7 - Input 'ints' were sorted to \(sortArray) in: \(totalSortActions) actions")

// working on Output #8
// the 11th value (118) was missing from the sorted sring in the coding_challenge1 file .. made this very interesting

// still stuck here .. thinking the 11th value was omitted and should be in the set for full comprehension as 118 corresponds to the lower case 'v' in ascii.
